.text

// this was mostly cribbed from the rockbox CRT

#include "config-h100.h"
#include "config.h"
#include "mcf5249.h"

_start:

/*
    move.l  #vectors,%d0
    movec.l %d0,%vbr
  */      
 
 //set up base registers
    move.l  #MBAR+1,%d0
    movec.l %d0,%mbar
        
    move.l  #MBAR2+1,%d0
    movec.l %d0,%mbar2

    lea     MBAR,%a0
    lea     MBAR2,%a1
        
    clr.l  (0x180,%a1)  /* PLLCR = 0 */

    /* 64K DMA-capable SRAM at 0x10000000
       DMA is enabled and has priority in both banks
       All types of accesses are allowed
       (We might want to restrict that to save power) */
       /* already set up by the AVR
    move.l  #0x10000e01,%d0
    movec.l %d0,%rambar1 */

    /* 32K Non-DMA SRAM at 0x10010000
       All types of accesses are allowed
       (We might want to restrict that to save power) */
       /* also already set up 
    move.l  #0x10010001,%d0
    movec.l %d0,%rambar0 */
#if 0
    /* Chip select 0 - Flash ROM */
    moveq.l #0x00,%d0      /* CSAR0 - Base = 0x00000000 */
    move.l  %d0,(0x080,%a0)
    move.l  #FLASH_SIZE-0x10000+1,%d0 /* CSMR0 - All access */
    move.l  %d0,(0x084,%a0)
    move.l  #0x00000180,%d0 /* CSCR0 - no wait states, 16 bits, no bursts */
    move.l  %d0,(0x088,%a0)
#endif
    move.l #0x10010000,%sp /* stack at the end of 1st RAM */

    jmp start_main

